<p align="center">
    <img alt="transbeam logo: a laser warning sign in trans flag colors" height="300" src="https://git.xeno.science/xenofem/transbeam/raw/branch/main/static/transbeam.svg">
</p>

# transbeam

A low-latency file drop server

## features

- One-to-many transfer of large files
- Simple web UI for sender and receivers
- Receivers can begin downloading *immediately*, without needing to
  wait for the upload to finish
- Receivers can also download after the upload is complete and the
  sender has gone offline
- Easy to send multiple files at once - they're bundled into a zip
  file for receivers, with zero compression so extraction is quick
- Sanitizes filenames
- Fires a laser beam that turns you trans

## configuration

transbeam is configured with the following environment variables:
- `STORAGE_DIR`: path where uploaded files should be stored (default: `./storage`)
- `STATIC_DIR`: path where the web app's static files live (default: `./static`)
- `PORT`: port to listen on localhost for http requests (default: 8080)

## installation

## configuration
## todo

- [ ] real-time file downloading
- [ ] upload progress bar
- [ ] uploader auth
- [ ] downloader auth
- [ ] delete uploads after a while
